=== release/ports/science/relax3d/Portfile ===
# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
# $Id: Portfile 109198 2013-08-09 22:09:15Z macsforever2000@macports.org $

PortSystem                1.0
PortGroup                 active_variants 1.1

name                      relax3d
version                   1.0.5
categories                science gis
platforms                 darwin
license                   GPL
maintainers               ntu.edu.sg:sbarbot openmaintainer
description               Semi-analytic solver for earthquake modeling.
long_description          Relax evaluates the displacement and stress \
                          in a half space with gravity due to dislocations, \
                          Mogi sources, and surface tractions\; and the nonlinear \
                          time-dependent deformation that follows due to \
                          power-law rheology materials in the bulk and or \
                          rate-strengthening friction faults.

homepage                  http://www.geodynamics.org/cig/software/relax/
master_sites              http://www.geodynamics.org/cig/software/relax/macports
use_bzip2                 yes

checksums                 rmd160 7f62d09c95691208c14ff3756d3dd230cd38458b \
                          sha256 232039a3bc8c9d2eb58292906484a8ee4550e178388f8e42f8bc9abd29d6487b

depends_lib-append        port:fftw-3-single \
                          port:gmt4 \
                          port:proj48 \
                          port:python27

# gmt4 is not universal
universal_variant no

configure.ldflags-append  "-L${prefix}/lib -lfftw3 -lfftw3_threads -lfftw3f -lfftw3f_threads"

configure.args            --use-fftw \
                          --fftw-dir=${prefix} \
                          --proj-incdir=${prefix}/include \
                          --proj-libdir=${prefix}/lib/proj48/lib \
                          --gmt-dir=${prefix}/lib/gmt4
configure.cmd             "./waf configure"

build.env-append          ${configure.env}
build.cmd                 "./waf build"
build.target              ""

destroot {
        xinstall -m 755 ${worksrcpath}/build/relax ${destroot}${prefix}/bin/relax
        xinstall -m 644 ${worksrcpath}/man/man1/relax.1 ${destroot}${prefix}/share/man/man1/relax.1
}

variant gcc45 conflicts gcc46 gcc47 gcc48 description {Compile with gcc 4.5} {
    configure.compiler macports-gcc-4.5
    require_active_variants   fftw-3-single gcc45
}

variant gcc46 conflicts gcc45 gcc47 gcc48 description {Compile with gcc 4.6} {
    configure.compiler macports-gcc-4.6
    require_active_variants   fftw-3-single gcc46
}

variant gcc47 conflicts gcc45 gcc46 gcc48 description {Compile with gcc 4.7} {
    configure.compiler macports-gcc-4.7
    require_active_variants   fftw-3-single gcc47
}

variant gcc48 conflicts gcc45 gcc46 gcc47 description {Compile with gcc 4.8} {
    configure.compiler macports-gcc-4.8
    require_active_variants   fftw-3-single gcc48
}

if {![variant_isset gcc45] && ![variant_isset gcc46] && ![variant_isset gcc47]} {
    default_variants +gcc48
}
